package com.paypal;

import java.io.IOException;
import java.io.InputStream;
import java.io.PrintWriter;
import java.io.UnsupportedEncodingException;
import java.net.URLDecoder;
import java.net.URLEncoder;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Properties;
import java.util.StringTokenizer;
import java.util.concurrent.TimeUnit;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.json.JSONObject;

import okhttp3.ConnectionSpec;
import okhttp3.MediaType;
import okhttp3.OkHttpClient;
import okhttp3.Request;
import okhttp3.RequestBody;
import okhttp3.Response;
import okhttp3.TlsVersion;

import javax.servlet.http.HttpServlet;

/**
 * Servlet implementation class GetEC
 */

/* 	This call takes token as a parameter and returns the transaction details	 */

@WebServlet("/getTransactionDetails")
public class GetEC extends HttpServlet {
	private static final long serialVersionUID = 1L;
	
	private static String USER ;
	private static String PWD ;
	private static String SIGNATURE ;
	private static String VERSION ;
	private static String METHOD ;
	private static String URL ;
	private static JSONObject obj;
	private static String userActionFlag;
	private static String environment;
	
	public JSONObject getShippingDetails (String paymentID) throws Exception {
		
		ConnectionSpec cs = new ConnectionSpec.Builder(ConnectionSpec.MODERN_TLS) // Set TLS VERSION 1.2
                .tlsVersions(TlsVersion.TLS_1_2)
                .build();
        List<ConnectionSpec> specs = new ArrayList<ConnectionSpec>();
            specs.add(cs);
            specs.add(ConnectionSpec.COMPATIBLE_TLS);
            specs.add(ConnectionSpec.CLEARTEXT);
            
        OkHttpClient client = new OkHttpClient.Builder()
                .connectTimeout(36000, TimeUnit.SECONDS)
                .writeTimeout(36000, TimeUnit.SECONDS)
                .readTimeout(36000, TimeUnit.SECONDS)
                .connectionSpecs(specs)
                .build();
		MediaType mediaType = MediaType.parse("application/octet-stream");
		
		Properties prop = new Properties();
		InputStream input = null;
		String filename = "config/config.properties";
		
		input = this.getClass().getClassLoader().getResourceAsStream(filename);  
		if(input==null){
			System.out.println("Sorry, unable to find "+filename);
			JSONObject error = new JSONObject();
			return error;
		}
		
		try {
			prop.load(input);
			this.setUserActionFlag(prop.getProperty("USERACTION_FLAG"));
			String strSandbox="";
			if(prop.getProperty("SANDBOX_FLAG").equals("true")){
				strSandbox="_SANDBOX";
				environment = "sandbox";
				USER = prop.getProperty("USER");
				PWD = prop.getProperty("PWD");
				SIGNATURE = prop.getProperty("SIGNATURE");
				URL = prop.getProperty("SANDBOX_URL");
			}
			else {
				USER = prop.getProperty("LIVE_USER");
				PWD = prop.getProperty("LIVE_PWD");
				SIGNATURE = prop.getProperty("LIVE_SIGNATURE");
				URL = prop.getProperty("LIVE_URL");
			}
			
			VERSION = prop.getProperty("VERSION");
			METHOD = prop.getProperty("GetEC_METHOD");
			
			try {
				String nvpstr = "USER=" + URLEncoder.encode(USER, "UTF-8");
				nvpstr = nvpstr + "&PWD=" + URLEncoder.encode(PWD, "UTF-8");
				nvpstr = nvpstr + "&SIGNATURE=" + URLEncoder.encode(SIGNATURE, "UTF-8");
				nvpstr = nvpstr + "&VERSION=" + URLEncoder.encode(VERSION, "UTF-8");
				nvpstr = nvpstr + "&METHOD=" + URLEncoder.encode(METHOD, "UTF-8");
				nvpstr = nvpstr + "&TOKEN=" + URLEncoder.encode(paymentID, "UTF-8");
				
				RequestBody body = RequestBody.create(mediaType, nvpstr);
				
				Request request = new Request.Builder()
				.url(URL)
				.post(body)
				.addHeader("cache-control", "no-cache")
				.build();
				
				try {
					Response response = client.newCall(request).execute();
					String payload = response.body().string();
					obj = deformatNVP(payload);

				} catch (IOException e) {
					e.printStackTrace();
					throw new Exception("Server Error");
				}

			} catch (UnsupportedEncodingException e) {

				e.printStackTrace();
			}
		} catch (IOException e1) {
			e1.printStackTrace();
		}
		System.out.println("From GetEC:\n"+obj);
		return obj;
	}
	
	public static JSONObject deformatNVP(String payload) {
		HashMap nvp = new HashMap(); 
		StringTokenizer stTok = new StringTokenizer( payload, "&");
		while (stTok.hasMoreTokens())
		{
			StringTokenizer stInternalTokenizer = new StringTokenizer( stTok.nextToken(), "=");
			if (stInternalTokenizer.countTokens() == 2)
			{
				String key = URLDecoder.decode( stInternalTokenizer.nextToken());
				String value = URLDecoder.decode( stInternalTokenizer.nextToken());
				nvp.put( key.toUpperCase(), value );
			}
		}
		
		JSONObject json = new JSONObject(nvp);
		return json;
	}
	
	
	
	protected void doGet(HttpServletRequest request, HttpServletResponse response) {
		
		PrintWriter writer = null;
		try {
			writer = response.getWriter();
			String id = request.getParameter("id");
			JSONObject json = getShippingDetails(id);
		
			writer.print(obj);  
		}
		catch(Exception e) {
			e.printStackTrace();
			String error = "ACK=Failure&L_LONGMESSAGE0="+URLEncoder.encode(e.getMessage());
			JSONObject errmess = deformatNVP(error);
			writer.println(errmess);
		} 
		
	}
	
	private void setUserActionFlag(String userActionFlag) {
		this.userActionFlag = userActionFlag;
	}
	
}